package org.globalse.oose.bumpers.cars;

import java.awt.*;

import org.globalse.oose.bumpers.cars.Car;
import org.globalse.oose.bumpers.cars.MouseSteering;
import java.util.ArrayList;

public class GameBoard extends Canvas{
	
	private static GameBoard INSTANCE;
	public static int NUMBER_OF_FAST_CARS = 3;
	public static int NUMBER_OF_SLOW_CARS = 3;

	private static Dimension DEFAULT_SIZE = new Dimension(500, 300);
	private static Color backgroundColor = Color.white;

	private DrivenCar theDrivenCar;
	private ArrayList robotCars = new ArrayList();
	
	private Image backgroundImage;
	private Graphics backgroundGraphics;
	private Dimension theSize;
	
	public static GameBoard getInstance(){
		if(INSTANCE == null){
			INSTANCE = new GameBoard();
		}
		return INSTANCE;
	}
	
	private GameBoard(){
		setSize(getPreferredSize());
		theDrivenCar = new DrivenCar();
		new MouseSteering(this, theDrivenCar);
		
	}
	
	public Dimension getPreferredSize(){
		return DEFAULT_SIZE;
	}
	
	public Car[] getRobotCars(){
		return (Car[])robotCars.toArray(new Car[robotCars.size()]);
	}
	
	public DrivenCar getDrivenCar(){ return this.theDrivenCar; }
	
	public void update(Graphics g) {
		if (theSize == null
			|| theSize.width  != getSize().width
			|| theSize.height != getSize().height) {
			theSize = getSize( );
			backgroundImage = createImage(theSize.width, theSize.height);
			backgroundGraphics = backgroundImage.getGraphics( );
		}
		paint(backgroundGraphics);
		g.drawImage(backgroundImage, 0, 0, null);
    }
	
    public void paint(Graphics g) {
		
		g.setColor(backgroundColor);
		g.fillRect(0, 0, getSize().width, getSize().height);
		
		Car[] carArray = getRobotCars();
		int num = carArray.length;
		for (int i = 0; i < num; i++) {
			paintCar(carArray[i], g);
			
		}
		paintCar(theDrivenCar, g);
    }
	
	private void paintCar(Car car, Graphics g) {
		Point carPosition = car.getPosition();
		Point canvasPosition = convertPosition(carPosition);
		g.drawImage(car.getBody(),
					canvasPosition.x,
					canvasPosition.y,
					car.getSize().width,
					car.getSize().height,
					null);
	}
	
	public void initiate() {
		theDrivenCar.initiate(getSize().width, getSize().height);
		
		this.robotCars.clear();
		for (int i = 0; i < NUMBER_OF_FAST_CARS; i++) {
			FastCar car = new FastCar(getSize().width,
									  getSize().height);
			robotCars.add(car);
		}
		for (int i = 0; i < NUMBER_OF_SLOW_CARS; i++) {
			SlowCar car = new SlowCar(getSize().width,
									  getSize().height);
			robotCars.add(car);
		}
		repaint();
	}
	
	public Point convertPosition(Point toConvert){
		return new Point(toConvert.x,
						 getSize().height - toConvert.y);
	}
}

