package org.globalse.oose.bumpers.cars.instruments.us;

import org.globalse.oose.bumpers.cars.instruments.InstrumentFactory;
import org.globalse.oose.bumpers.cars.instruments.Body;
import org.globalse.oose.bumpers.cars.instruments.GPS;
import org.globalse.oose.bumpers.cars.instruments.RotationsPerSecond;
import org.globalse.oose.bumpers.cars.instruments.Speedometer;
import org.globalse.oose.bumpers.cars.instruments.SpeedController;
import org.globalse.oose.bumpers.cars.DrivenCar;

public class USFactory extends InstrumentFactory {
	
	private static USFactory INSTANCE;
	
	private USFactory(){}
	
	public static InstrumentFactory getInstance(){
		if(INSTANCE == null){
			INSTANCE = new USFactory();
		}
		return INSTANCE;
	}
	public RotationsPerSecond createRotationsPerSecond(DrivenCar theCar) {
		return new USRotationsPerSecond(theCar);
	}
	
	public SpeedController createSpeedController(DrivenCar theCar) {
		return new USSpeedController(theCar);
	}
	
	public Speedometer createSpeedometer(DrivenCar theCar) {
		return new USSpeedometer(theCar);
	}
	
	public Body createBodyView(DrivenCar theCar) {
		return new USBody(theCar);
	}
	
	public GPS createGPS(DrivenCar theCar) {
		return new USGPS(theCar);
	}
}

